/// Теоретичні питання

// Опишіть своїми словами, що таке метод об'єкту
// Відповідь: фактично це вбудована функція з викликом, яка міститься в самому об'єкті і задана
// як одна з властивостей такого об'єкту. методів в об'єкті може бути безліч. Метод може викликати дію для об'єкта.
// Метод може мати посилання на конкретний об'єкт через використання в ньому this. у стрілкових методах/функціях this. бере
// значення ззовні, а не в самому об'єкті.

// Який тип даних може мати значення властивості об'єкта?
// Відповідь: null

// Об'єкт це посилальний тип даних. Що означає це поняття?
// Відповідь: це означає, що об'єкт може містити декілька властивостей з різними значеннями, але задається як один тип даних,
// на відміну від примітивного типу даних, де зазначається лише одне значення. При цьому, змінна, яка має тип даних Об'єкт такого
// явно вираженого значення не містить, а містить посилання на дані, до яких можна в подальшому звертатись та взаємодіяти.

/// Завдання

// Реалізувати функцію створення об'єкта "юзер". Завдання має бути виконане на чистому
// Javascript без використання бібліотек типу jQuery або React.

// Технічні вимоги:
// Написати функцію createNewUser(), яка буде створювати та повертати об'єкт newUser.
// При виклику функція повинна запитати ім'я та прізвище.
// Використовуючи дані, введені юзером, створити об'єкт newUser з властивостями
// firstName та lastName.
// Додати в об'єкт newUser метод getLogin(), який повертатиме першу літеру імені юзера,
// з'єднану з прізвищем, все в нижньому регістрі (наприклад, Ivan Kravchenko → ikravchenko).
// Створити юзера за допомогою функції createNewUser(). Викликати у цього юзера функцію getLogin().
// Вивести у консоль результат виконання функції.

function createNewUser() {
  return {
    firstName: readFirstName(),
    lastName: readLastName(),
    setFirstName(firstName){
this.firstName = firstName;
    },
    getLogin() {
      return (this.firstName.slice(0, 1) + this.lastName).toLowerCase();
    }
  }
}

let newUser = createNewUser();
let newUser2 = createNewUser();

console.log(newUser.getLogin());
console.log(newUser2.getLogin());

// Необов'язкове завдання підвищеної складності
// Зробити так, щоб властивості firstName та lastName не можна було змінювати напряму.
// Створити функції-сеттери setFirstName() та setLastName(), які дозволять змінити дані властивості.
function readFirstName() {
  return prompt("Please ener your first name.");
}
function readLastName() {
  return prompt("Please ener your last name.");
}
